VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1260
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6900
   LinkTopic       =   "Form1"
   ScaleHeight     =   1260
   ScaleWidth      =   6900
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   360
      TabIndex        =   0
      Top             =   360
      Width           =   6135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Example 2b: Read then verify a user secret from a SmartDongle.
'
' MicroWorks, Inc.
' 2808 North Cole Road
' Boise, ID 83704
'
' http://www.smartdongle.com

Option Explicit

' For SmartDongle access
Private Const SecretAddress = 0
Private Const SecretSize = 16

'  uskvb.dll functions
Private Declare Function LedRed Lib "..\usk_vb" () As Integer
Private Declare Function LedGreen Lib "..\usk_vb" () As Integer
Private Declare Function VBRead Lib "..\usk_vb" ( _
  ByVal P1 As String, _
  ByVal P2 As String, _
  ByVal address As Long, _
  ByVal buffer As String, _
  ByVal size As Long _
) As Integer



Private Sub Form_Load()

   Dim status As Integer   ' Function return value
   Dim errStr As String    ' Formatted error string
   Dim yourSecret As String

   ' SmartDongle Access vars
   Dim P1 As String        ' Key 1
   Dim P2 As String        ' Key 2
   Dim address As Integer  ' SmartDongle memory address
   Dim buffer As String    ' Input buffer for encrypted secret from SmartDongle
   Dim size As Integer     ' Input buffer size
      
   ' SmartDongle Demo Keys
   P1 = "0xec6cc589aefd1e75"
   P2 = "0xfcec0a6a82747b3f"

   ' Expected SmartDongle secret
   yourSecret = "~JIKp=bm:-9+wn9}"
   buffer = String(SecretSize, vbNullChar)
   
   Form1.Caption = "Read and Decrypt Your SmartDongle Secret"
   Form1.Show
   Form1.Refresh
   
   ' Indicate "Verification in progress"
   LedRed
   
   ' Attempt to read encrypted secret from SmartDongle using demo keys
   address = SecretAddress
   size = SecretSize
   status = VBRead(P1, P2, address, buffer, size)
   If status Then
      errStr = Format(status)
      Text1.Text = "FAILED: SmartDongle Access Failed with Error Code " & errStr
      GoTo FAIL
   End If
   
   ' Compare with your secret
   If StrComp(Left$(buffer, SecretSize), Left$(yourSecret, SecretSize)) Then
      Text1.Text = "FAILED: Invalid SmartDongle Secret"
      GoTo FAIL
   End If

   ' Indicate "Secret Verified"
   LedGreen
   Text1.Text = "SUCCESS: Valid SmartDongle Secret"
   
FAIL:
   Form1.Refresh

End Sub
